/*
 * Copyright 2022 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.eactive.eai.rms.data.config;

import org.hibernate.context.spi.CurrentTenantIdentifierResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import com.eactive.eai.rms.common.datasource.DataSourceContextHolder;
import com.eactive.eai.rms.common.datasource.DataSourceType;
import com.eactive.eai.rms.common.datasource.DataSourceTypeManager;

@Component
public class TenantIdentifierResolver implements CurrentTenantIdentifierResolver {

	private static final Logger logger = LoggerFactory.getLogger(TenantIdentifierResolver.class);

	@Override
	public String resolveCurrentTenantIdentifier() {

		DataSourceType dataSourceType = DataSourceContextHolder.getDataSourceType();

		if (dataSourceType == null) {
			dataSourceType = DataSourceTypeManager.getDataSourceType(DataSourceTypeManager.MONITORING);
			logger.debug("DataSource가 명시적으로 선택되지 않았으므로, MONITORING DataSource를 사용합니다.");
		}

		return dataSourceType != null ? dataSourceType.getName() : null;
	}

	@Override
	public boolean validateExistingCurrentSessions() {
		return true;
	}

}
